﻿
; Tracer Directives         => ;$DisableDebugOutput() or ;$DisDBG - and ;$EnableDebugOutput() or ;$EnDBG
;                           => $LPP from Little PreProcessor (these lines are Skipped)

EnableExplicit

Global LPPF.b          = 0
Global sTabLen.s       = "   "
Global gMainInpFN.s

IncludeFile "TracerAuxFunct.pbi"


Define InpFN.s, OutFN.s
Define MaxKW, st.s
Define Progr, pbPID, hWnd, ret
; Define SkipCurrLineF, BlockSkipF, sTimer.s, CurrProcName.s

; 0 = add line nr only, 1 = add procedure name, 2 = add procedure address, 
; 4 = add line nr address

#ADDFLAG_LINENR     = 0             ; bitflag
#ADDFLAG_PROCNAME   = 1
#ADDFLAG_PROCADDR   = 2
#ADDFLAG_LINEADDR   = 4

; error codes
#FILE_ALREADY_TRACED = #WM_USER + 100

#CRLF2$ = #CRLF$ + #CRLF$

Define CmdLn.s


Define ini, fin
Global sDebug.s
Global sFilter.s
Global Target.s            = "DebugView"; "StdFile"
Global AddFlag.b           = #ADDFLAG_PROCNAME | #ADDFLAG_PROCADDR     

Global AddCodeF.b          = 1      ; add line code in the output string
Global LineNrLen            = 5     ; space in characters of the line number field
Global ProcNameLen          = 20    ; space in characters of the procedure name field
Global ProcAddrLen          = 8     ; space in characters of the procedure address field
Global HexAddrF             = 1     ; write hex numbers
Global StartWithEmptyLineF  = 1     ; send an empty line at the the beginning of the debug session
Global SepProcCallsF.b      = 1     ; add an empty line at the entry of every procedure (for readeability)
Global ShowVarsF.b          = 1     ; enable the Variable view feature
Global MissinglDebugF       = 0     ; if the lDebugF procedure is missing (and needed); if so include a reference to a file
                                     ;    that must be in the source directory
Global MissingHRTimerF      = 1     ; if the HRTimer procedure is missing (and needed); if so include a reference to a file
Global ClearDebugViewLogF   = 1     ; try to clear debugview log list
Global RunPBF.b             = 0
Global OnlyIfNewerF.b       = 1
Global FixedTraceLen        = 125
Global SilentF.b            = 0
Global TestCompileF.b       = 1
Global ScanInlcudedFiles    = 1
Global AddRunInfoF.b        = 1
Global SameDestFolderF.b    = 1
Global ShowRunParamsF.b     = 0 

If CountProgramParameters() = 0 Or ProgramParameter(0) = "/?" Or LCase(ProgramParameter(0)) = "/h" Or LCase(ProgramParameter(0)) = "/hd"
    OpenConsole()
        
        PrintN("Program: "+GetFilePart(#PB_Compiler_File)+" - ver. 0.0.2.0 (Build:"+Str(#pb_editor_buildcount)+")")
        PrintN("By: Carlo Somigliana - somic@libero.it, www.semelinanno.com")
        PrintN("Written in PureBasic - ver. "+StrD(#PB_Compiler_Version/100, 2)+" (x86)")
        PrintN("")
        PrintN("A program to automatically add debug output code to PB souces.")
        PrintN("Written to trace programs that can not debugged in the PB IDE (es. dlls)")
        PrintN("")
        PrintN("Try it with a Debug Viewer program (es. DebugView by Sysinternals@)")
        ; PrintN(" Copyright@ 1998 - 2008 by Mark Russinovich - www.sysinternals.com)"); (Pls note that Microsoft@ acquired Sysinternals in July, 2006 but utils are still available)"
        PrintN("")
        PrintN("Code and binary are FREEWARE. Use and modify at YOUR OWN WISH and RISK.")
        PrintN("-------------------------------------------------------------------------------")

        ShowHelp(ProgramParameter(0))
        
        Input()
    
    CloseConsole()
    End
Else

    InpFN = ProgramParameter(0) 
    OutFN = GetCmdLineParam(CmdLn, "/o") 
    CmdLn = LCase(PeekS(GetCommandLine_()))
    
;     CmdLn = Chr(34)+"C:\Program Files\PureBasic_430\Arch\CPU_Clock\EnTimer.pbi"+Chr(34)+" "+Chr(34) + "C:\Program Files\PureBasic_430\Arch\CPU_Clock\EnTimer_.pbi"+Chr(34)
;     cmdln = cmdln + "/t DebugView /af 3 /x /c /ln5 /pn20 /pa8 /v /r"
    
    If FindString(CmdLn, "/def", 1) <> 0 Or FindString(CmdLn, "/d", 1) <> 0:     ; default config
        Target               = "DebugView"
        AddFlag              = #ADDFLAG_PROCNAME | #ADDFLAG_PROCADDR 
        AddCodeF             = 1     ; tells the program to add line code in the output string
        LineNrLen            = 5     ; space in characters of the line number field
        ProcNameLen          = 20    ; space in characters of the procedure name field
        ProcAddrLen          = 8     ; space in characters of the procedure address field
        FixedTraceLen        = 125   ; space in characters of the procedure address field
        HexAddrF             = 1     ; tells the program to write hex numbers
        StartWithEmptyLineF  = 1     ; tells the program to send an empty line at the the beginning of the debug session
        SepProcCallsF        = 1     ; tells the program to add an empty line at the entry of every procedure (for readeability)
        ShowVarsF            = 1     ; tells the program to enable the Variable view feature
        MissinglDebugF       = 0     ; tells the program if the lDebugF procedure is missing (and needed); if so include a reference to a file
                                             ;    that must be in the source directory
        MissingHRTimerF      = 1     ; tells the program if the HRTimer procedure is missing (and needed); if so include a reference to a file
        ClearDebugViewLogF   = 1     ; try to clear
        RunPBF               = 0     ; tells the program to run the purebasic editor after Tracing
        OnlyIfNewerF         = 0     ; tells the program execute only if source file is newer than dest file
        SilentF              = 0     ; tells the program to run without prompting messages
        TestCompileF         = 0     ; tells the program to test the generated code trying to compile it
        ScanInlcudedFiles    = 0     ; tells the program to trace also file in the IncludeFile keyword; modify instruction
        AddRunInfoF          = 1     ; add a RunInfo comment in the first line
        SameDestFolderF      = 1     ; 
        ShowRunParamsF       = 0      ; 
    EndIf 

    Target = GetCmdLineParam(CmdLn, "/tg")                          ; add Default value only when <> 0
    sFilter = GetCmdLineParam(CmdLn, "/fl")
    AddFlag = Val(GetCmdLineParam(CmdLn, "/af", Str(AddFlag)))
    AddCodeF = Val(GetCmdLineParam(CmdLn, "/ac", Str(AddCodeF)))
    LineNrLen = Val(GetCmdLineParam(CmdLn, "/ln", Str(LineNrLen)))
    ProcNameLen = Val(GetCmdLineParam(CmdLn, "/pn", Str(ProcNameLen)))
    ProcAddrLen  = Val(GetCmdLineParam(CmdLn, "/pa", Str(ProcAddrLen)))
    FixedTraceLen = Val(GetCmdLineParam(CmdLn, "/xc", Str(FixedTraceLen)))
    
    HexAddrF            = Val(GetCmdLineParam(CmdLn, "/he", Str(HexAddrF)))
    StartWithEmptyLineF = Val(GetCmdLineParam(CmdLn, "/el", Str(StartWithEmptyLineF)))
    SepProcCallsF       = Val(GetCmdLineParam(CmdLn, "/sp", Str(SepProcCallsF)))
    MissinglDebugF      = Val(GetCmdLineParam(CmdLn, "/md"))
    MissingHRTimerF     = Val(GetCmdLineParam(CmdLn, "/hr", Str(MissingHRTimerF)))
    ClearDebugViewLogF  = Val(GetCmdLineParam(CmdLn, "/cd", Str(ClearDebugViewLogF)))
    RunPBF              = Val(GetCmdLineParam(CmdLn, "/rn"))
    TestCompileF        = Val(GetCmdLineParam(CmdLn, "/tc"))
    OnlyIfNewerF        = Val(GetCmdLineParam(CmdLn, "/on"))
    SilentF             = Val(GetCmdLineParam(CmdLn, "/sl", Str(SilentF)))
    ScanInlcudedFiles   = Val(GetCmdLineParam(CmdLn, "/if"))
    AddRunInfoF         = Val(GetCmdLineParam(CmdLn, "/ri", Str(AddRunInfoF)))
    SameDestFolderF     = Val(GetCmdLineParam(CmdLn, "/sd", Str(SameDestFolderF)))
    
    ShowVarsF           = Val(GetCmdLineParam(CmdLn, "/sv", Str(ShowVarsF)))
    ShowRunParamsF      = Val(GetCmdLineParam(CmdLn, "/rp"))
EndIf

CompilerIf #PB_Compiler_Debugger
    If InpFN = ""
        InpFN = "C:\Program Files\PureBasic_430\Arch\CPU_Clock\EnTimer.pbi"
    EndIf
CompilerEndIf

gMainInpFN = InpFN

If OutFN = ""
    OutFN = GetPathPart(InpFN)+"_$_"+GetFilePart(InpFN)
    
ElseIf PathIsDirectory_(OutFN)
    PathAddBackslash_(OutFN)
    OutFN = OutFN+"_$_"+GetFilePart(InpFN)
    
EndIf

If OnlyIfNewerF
    Define InpFtime, OutFTime
    InpFTime = GetFileDate(InpFN, #PB_Date_Modified)
    OutFTime = GetFileDate(OutFN, #PB_Date_Modified)
    If InpFTime <= OutFTime 
        If Not SilentF : MessageRequester("Tracer", "Input File older than Output. Nothing done."): EndIf
        End 0
        
    EndIf
    
EndIf


; /////////////////////////////////////////////////////////////////////////////////////
; /// look for nr of space characters for each Tab to improve allignement of strings
Define PBprefs.s = ""   ; sTabLen is defaulted 4 spaces "    "; if not found it is not a critical error

If FindString(LCase(PeekS(GetCommandLine_())), "/local", 1)     ; test for /local directive
    PBprefs = GetPathPart(gMainInpFN)+"Purebasic.prefs"              
        
EndIf

If Not FileSize(pbPrefs)
    PBprefs = #PB_Compiler_Home+"Purebasic.prefs"

EndIf    

If Not FileSize(pbPrefs)
    PBPrefs = GetEnvironmentVariable("APPDATA")+"\Purebasic\Purebasic.prefs"

EndIf    
st = Space(100)
k = GetPrivateProfileString_("Global", "TabLength", "4", st, 100, pbPrefs)
sTabLen = Space(Val(st))                                    ; if not found it is not a critical error
; //////////////////////////////////////////////////////////////////////////////////////////////    

Select Target
    Case "StdFile"                  ; save Debug Output to std file (c:\pbfilename.dbg)
        sDebug = "lDebugF"          ; THIS OPTION SENSIBLY SLOWS DOWN THE EXECUTION 
                                    ; write To file; the DebugF() function must be defined (copied) in the target code
                                    ; if it is not found it will be added the line InculdeFile "lDebugF()"
                                    ; this file must be in the program directory
;     Case "CustFile"                 ; save Debug Output to custom file
;         sDebug = "DebugF"
    Case "DebugView"               ; use API OutputDebugString_ (a pipe for debug - IT IS VERY FAST)
        sDebug = "OutputDebugString_"
        
    Default
        sDebug = "OutputDebugSTring_"
        
EndSelect





; sFilter = "pbPrjMgr.pb"         ; this is the name of the output file, used as filter by the DebugView App (SysInternals)
If sFilter = ""
    sFilter = GetFilePart(gMainInpFN)
EndIf


If sDebug = "lDebugF"
    MissinglDebugF = 1 ; ScanForlDebugF()
Else
    MissinglDebugF = 0
EndIf


Procedure TraceFile(InpFN.s, OutFN.s)
Protected InpFId, ExitCode, sf, OutFId, sLine.s, sInpLine.s, pos, LineNr, SkippedLines
Protected LastActFlag, SingleLineActFlag, SkipCurrLineF, BlockSkipF, HeaderWrittenF, ret
Protected CurPath.s, sInclFN.s, sInclOutFN.s, sInclPath.s, sXIncl.s
    ; InpFN = "c:\program files\purebasic_430\arch\plugin\pbPrjMgr.pb"
Protected sLineNr.s, ProcName.s, CurrProcName.s, sProcName.s, ProcAddr.s, sProcAddr.s, sLineAddr.s, sCode.s
Protected st.s, sStartLine.s, sTrace.s, sTimer.s, EndOfCodeF, sProcedures.s, sSameDestPath.s, Cond_SKIP_THIS_LINE
    
    ; MessageRequester(Left(GetFilePart(InpFN), 3), "")
    
    If Left(GetFilePart(InpFN), 3) = "_$_"
        ExitCode = #FILE_ALREADY_TRACED
        If Not SilentF
            MessageRequester("Tracer", "Input File already Traced."+#CRLF$+InpFn)
        EndIf
        ProcedureReturn ExitCode    
        
    EndIf
    
    InpFId = ReadFile(#PB_Any, InpFN)
    If Not InpFId
        ExitCode = GetLastError_()
        If Not SilentF
            MessageRequester("Tracer", "Input File not found."+#CRLF$+InpFn+ #CRLF2$ + "API Error code: "+Str(ExitCode))
        EndIf
        ProcedureReturn ExitCode
        ; End ExitCode
    EndIf
    
    If InpFId
        sf = ReadStringFormat(InpFId)
        OutFId = CreateFile(#PB_Any, OutFN)
        WriteStringFormat(OutFId, sf)
    
        CurPath = GetPathPart(InpFN)
        If CurPath = ""
            CurPath = GetPathPart(PeekS(GetCommandLine_())) ; GetCurrentDirectory()
        EndIf
        sSameDestPath = CurPath                                    ; save all files in the same Path
        ; Debug "   CurPath= "+CurPath

        While Not Eof(InpFId)
            
            sLine = ReadString(InpFId, sf)
            sInpLine = sLine
            Debug RSet(Str(linenr), 4) + " - " + sLine
            
            LineNr = LineNr + 1         ; counter out of second while wend loop
            
            ; test to see if it is an IncludeFile or IncludePath instruction
            
            pos = FindString(sLine, ";", 1)
            If pos 
                sLine = Left(sLine, pos-1)                          ; strip comments
            
            EndIf
    
            sXIncl = ""
            sInclFN = StringFieldKey(sLine, LCase("IncludeFile"), "", "/")
            
            If sInclFN = "" 
                sInclFN = StringFieldKey(sLine, LCase("XIncludeFile"), "", "/")
                If sInclFN <> "" : sXIncl = "X": EndIf                
            EndIf
            sInclPath = StringFieldKey(sLine, LCase("IncludePath"), "", "/")
            
            If sInclFN <> "" Or sInclPath <> ""
                sInclFN = Mid(sInclFN, 2, Len(sInclFN)-2)           ; removes the two quotes at begin and end of string
                sInclPath = Mid(sInclPath, 2, Len(sInclPath)-2)     ; removes the two quotes at begin and end of string
                
                If sInclFN <> "" And sInclPath = ""
                    If PathIsRelative_(sInclFN)
                        sInclFN = CurPath + sInclFN
                    Else
                        ; no changes
                    EndIf

                    If SameDestFolderF                    
                        sInclOutFN = sSameDestPath+"_$_"+GetFilePart(sInclFN)
                    Else
                        sInclOutFN = GetPathPart(sInclFN)+"_$_"+GetFilePart(sInclFN)
                    EndIf
                    sLine = sXIncl + "IncludeFile " +Chr(34)+ sInclOutFN  + Chr(34)         ; set  file to include (itself)
                    
                    TraceFile(sInclFN, sInclOutFN)                                          ; recursively call TraceFile
                    
                ElseIf sInclFN = "" And sInclPath <> ""
                    CurPath = sInclPath
                    sLine = "IncludePath " +Chr(34)+ sInclPath  + Chr(34)                   ; set  path to include (itself)
                    
                EndIf
                                
            EndIf

            ; /////////////////////////////////////////////////////////////////////////////////////////////////////
            ; /// SKIP EMPTY LINES  
    
            ; used for debugging purpose
            If LineNr = 890
                CallDebugger
            EndIf
            ; Debug Str(LinenR)+" ******** CurrProcName :"+CurrProcName

            If Trim(sLine) = "" 
                If Not HeaderWrittenF And LineNr < 5
                    Goto Write1stLine    
                Else
                    Goto WritesLine    
                
                EndIf
            EndIf
            
    
            ; /////////////////////////////////////////////////////////////////////////////////////////////////////
            ; /// Get ActionCode associate with the line/instruction/keyword
            
            pos = CheckSkipKeyWord(sLine)
            Cond_SKIP_THIS_LINE  = ((LastActFlag = #START_SKIP_ALL_DIRECTIVE) And (LineActionFlag(pos) <> #STOP_SKIP_ALL_DIRECTIVE))
            Cond_SKIP_THIS_LINE  = Cond_SKIP_THIS_LINE And ((LastActFlag <> #TRACE_LOOPS_DIRECTIVE) And (LineActionFlag(pos) <> #STOP_SKIP_ALL_DIRECTIVE) )
            
;             CondElseIf2 = (LastActFlag = #START_SKIP_ALL_DIRECTIVE) And (LineActionFlag(pos) <> #STOP_SKIP_ALL_DIRECTIVE) 
;             CondElseIf2 = CondElseIf1 And (LastActFlag = #START_SKIP_ALL_DIRECTIVE) And (LineActionFlag(pos) <> #STOP_SKIP_ALL_DIRECTIVE) 
;      
            ; manages the MultipleLines character (es. ' _' for the $LPP = LittlePreProcessor)
            ; lines are skipped entirely
            If (LastActFlag = #SKIP_2_LINES) And (LineActionFlag(pos) = #DONT_SKIP_THIS_LINE)
                LastActFlag = #SKIP_THIS_LINE
                SingleLineActFlag = #SKIP_THIS_LINE
                
            ElseIf Cond_SKIP_THIS_LINE 
                ; LastActFlag = #START_SKIPPING_DIRECTIVE
                SingleLineActFlag = #SKIP_THIS_LINE
                
            ElseIf LastActFlag = #START_PB_SETTINGS
                ; nothing done 
                ; CallDebugger       
            Else
                LastActFlag = LineActionFlag(pos)
                SingleLineActFlag = LineActionFlag(pos)
            
            EndIf
                     
            SkipCurrLineF = SingleLineActFlag | BlockSkipF 
            
            If (SingleLineActFlag = #START_BLOCK_SKIPPING_FROM_THIS_LINE) Or (SingleLineActFlag = #START_LOOP_SKIPPING_FROM_THIS_LINE)
                BlockSkipF = 1
            
            ElseIf (SingleLineActFlag = #STOP_BLOCK_SKIPPING_FROM_THIS_LINE)
                SkipCurrLineF = 0
                BlockSkipF = 0
    
            ElseIf (SingleLineActFlag = #STOP_BLOCK_SKIPPING_FROM_NEXT_LINE)
                BlockSkipF = 0
            
            ElseIf (SingleLineActFlag = #TRACE_THIS_LINE)                       ; override everything
                SkipCurrLineF = 0
                
            EndIf
    
    ;         ; check for comment lines after the CheckSkipKeyWord because some directives (es. ;$DisableDebugOutput and ;$EnableDebugOutput())
    ;         ; are written as comments for simplicity (to avoid to add empty procedures)
    ;         If Left(Trim(sLine), 1) = ";"                   ; comment line
    ;             Goto WritesLine    
    ;         EndIf
        
                    
            ; ///////////////////////////////////////////////////////////////////////////////////////////////////////
            ; /// 1. look for the keyword Procedure to get the name
            ; /// 2. build the debug output string (first assmeble the SUBstrings that will build the final line)
     
            ; *** LINE NR
            
            sLineNr = RSet(Str(LineNr), LineNrLen, " ")                                  ; string for line numbers
    
                ; If pos <> ProcRetId
                ProcName = GetKeyWord(sLine, "procedure", ProcIdx)
                If ProcName <> ""
                    ; ProcName = StringFieldKey(sLine, "procedure", "")
                    CurrProcName = ProcName
;                     sProcedures = RemoveString(sProcedures, CurrProcName, #PB_String_NoCase)
;                     sProcedures = sProcedures + " "+CurrProcName
                EndIf
            ;EndIf
                     
                        
            ; *** PROCEDURE NAME

            If AddFlag & #ADDFLAG_PROCNAME                          ; add procedure name (= #PB_Compiler_Procedure)
                If HexAddrF And (ProcName <> "")                    ; compact line
                    sProcName = ", '+#PB_Compiler_Procedure "       ; purebasic instruction
                Else
                    If CurrProcName <> ""
                        sProcName = ", '+LSet('"+CurrProcName+"', "+Str(ProcNameLen)+")"                       ; purebasic instruction
                    Else
                        sProcName = ", '+LSet(#PB_Compiler_Procedure, "+Str(ProcNameLen)+")"                       ; purebasic instruction
                    EndIf
                EndIf
                sProcName = ReplC(sProcName)
                ; SetClipboardText(sProcName)
            Else
                sProcName = ""
            EndIf
            
            ; *** PROCEDURE ADDRESS 
            
            If (AddFlag & #ADDFLAG_PROCADDR) And (ProcName <> "")   ; add procedure address (= [Hex]@ProcedureName())

                ProcAddr = "@"+ProcName+"()"
                If HexAddrF                                         ; Hexadecimal memory addresses
                    sProcAddr = "+'($'+Hex("+ProcAddr+")+')'+' => '" 
               Else
                    sProcAddr = "+'('+LSet(Str("+ProcAddr+"), "+Str(ProcAddrLen)+")+')'"           
                EndIf
                sProcAddr = ReplC(sProcAddr)
                
            Else
                sProcAddr = ""
            EndIf
    
            ; *** LINE ADDRESS
                 
            If AddFlag & #ADDFLAG_LINEADDR                          ; add line nr address (ASM) - to be implemented
                sLineAddr = ", ASM"
            Else
                sLineAddr = ""   
            EndIf
            
            ; *** ORIGINAL CODE
            
            If AddCodeF
                sCode = Trim(sLine)                                 ; remove comment (for shortening the line)
                pos = FindString(sCode, ";", 1)
                If pos
                    sCode = RTrim(Mid(sCode, 1, pos-1))
                EndIf
                
                sCode = "+"+ Chr(34)+ "'"+ ReplaceString(sCode, Chr(34), "'") +"'"+Chr(34)
            
            Else
                sCode = ""
            EndIf
    
    
            ; ////////////////////////////////////////////////////////////////////////////////////////////////////
            ; /// manage the assembly of the result string
            ;
            If Not HeaderWrittenF And SkipCurrLineF <> #SKIP_LPP_DIRECTIVE                              ; write first line              
            
Write1stLine:
                If (MissinglDebugF Or MissingHRTimerF) 
                                                                ; we don't care about having the same line numbers between source and 
                                                                ; destination because the destination is really messy and almost useless 
                                                                ; (needed only for compiling the dll)
    
                    st = "XIncludeFile "+Chr(34)+GetPathPart(gMainInpFN )+"_$_TracerAux.pbi"+Chr(34)
                        CreateFile(1, GetPathPart(InpFN)+"_$_TracerAux.pbi")
                        WriteData(1, ?lblPBSource, ?EndlblPBSource - ?lblPBSource)
                        CloseFile(1)
    ;                 If GetFileSize(#PB_Compiler_FilePath+"TracerAux.pbi") = 0
    ;                     CopyFile(#PB_Compiler_FilePath+"TracerAux.pbi", get#PB_Compiler_FilePath+"TracerAux.pbi")
    ;                 EndIf
                    
                    ; WriteStringN(OutFId, ReplC(st))                  ; just write and includefile line and don't increment line counter
                    MissinglDebugF = 0                          ; lDebugF is now available (do not repeat this code)
                    MissingHRTimerF = 0                          ; lDebugF is now available (do not repeat this code)
                EndIf
    
                ; If AddRunInfoF
                 If AddRunInfoF
                    sStartLine = sStartLine + "; Run Info: "+FormatDate(Chr(34)+"%dd/%mm/%yyyy - %hh:%ii:%ss)"+Chr(34), Date())
                                                ; RunInfo = "13/09/1999 01:12:13- Il Debello gallico"
                EndIf
   
                If StartWithEmptyLineF                          ; add a START message as the first output string: adding this line of code at 
                                                                ; the beginning of the source code forces the program to execute it at first
                    sStartLine = sDebug+"("+Chr(34)+sFilter+": START "+Chr(34)+"): " + sStartLine
                    
                EndIf
                ; sStartLine = sStartLine + sDebug+"('"+sFilter+": Line, Procedure, ProcAddress, LineAddr'): "
                sStartLine = sStartLine + #CRLF$ + sDebug+"('"+sFilter+": "+LSet("Line Nr.", LineNrLen)+","+LSet("Procedure", ProcNameLen)+","+LSet("ProcAddress", ProcAddrLen)+"'):"; +, , LineAddr'): "
                
                WriteStringN(OutFId, ReplC(sStartLine))
                ; SetClipboardText(sTrace)
                HeaderWrittenF = 1                              ; disable writting the header (written only the first time)
    
            ElseIf Not SkipCurrLineF                            ; assemble the debug output string
    
                sTrace = sDebug+"("+Chr(34)+sFilter+": " + sLineNr + sProcName + sProcAddr + sLineAddr + sCode +")" ; +":"
                ; will AddSpaces later
                
            ElseIf SingleLineActFlag = #ADD_CMD_HRTIMER_START
                sTimer = "HRTimer(#HRT_START)"
                sTrace = sDebug+"("+Chr(34)+sFilter+": " + sLineNr + sProcName +") :"+ sTimer
                sTrace = AddSpaces(sTrace, FixedTraceLen)
                sLine = sTrace + ": "+sLine
                
            ElseIf SingleLineActFlag = #ADD_CMD_HRTIMER_STOP
                sTimer = "HRTimer(#HRT_GET_ns)"
    
                ;OutputDebugString_("HiResTimer:"+Str(HiResTimer(#HRT_ACT_STOP, #Null)))
                sTrace = sDebug+"("+Chr(34)+sFilter+": " + sLineNr + ", HRTimer:"+Chr(34)+"+Str(" +sTimer+"))"
    ;            sLine = SetFixedLen(sTrace, FixedTraceLen, " ")
                sTrace = AddSpaces(sTrace, FixedTraceLen)
                sLine = sTrace + ": " + sLine
                
            EndIf
    
    
            If Not SkipCurrLineF                                            ; add to the debug output string the original code (to be executed)
    
                If Trim(sInpLine) <> "" And Left(Trim(sInpLine), 1) <> ";"  
                    sTrace = AddSpaces(sTrace, FixedTraceLen)
                    If DbgStrAfter(pos)
                        sLine = sTrace + ": "+ sLine                        ; add Trace code
                    Else
                        sLine = sLine + ": " +sTrace                        ; add trace code AFTER the source code
                    EndIf
                    ; Debug Len(sTrace)
                    
                Else                                                        ; if it is an empty line => Skip
                    SkippedLines + 1    
                    SkipCurrLineF = #True
                    sLine = Space(FixedTraceLen)+": "+sLine
                EndIf
            Else                                                            ; SepProcCallsF superseed LineActionFlag (If Not in a skip all directive)
            
                ;If ProcName And (AddFlag & #ADDFLAG_PROCADDR) And (LastActFlag <> #START_SKIP_ALL_DIRECTIVE)
                If DbgStrAfter(pos) And (LastActFlag <> #START_SKIP_ALL_DIRECTIVE) And (LastActFlag <> #SKIP_LOOPS_DIRECTIVE)
                    If SepProcCallsF                ; Separate Procedure Calls: add a debug instruction to have an empty line
                        sLine = sLine + ": " + sDebug+"("+Chr(34)+sFilter+": "+Chr(34)+")"
                        
                    EndIf
                    sLine = AddSpaces(sLine, FixedTraceLen)                 ; add spaces to the source code line
                    sLine = sLine + ": " +sTrace                            ; add trace code AFTER the source code
                    SkipCurrLineF = #False
    
                Else
                    SkippedLines + 1    
                    SkipCurrLineF = #True
                    ; sLine = Space(FixedTraceLen)+": "+sLine
                    
                EndIf
            
            EndIf        
                
    WritesLine:
        
            ;PB settings may have been saved at the end of the source file
            
            If SingleLineActFlag = #START_PB_SETTINGS And Not EndOfCodeF
                sTrace = sDebug+"('"+sFilter+": STOP '): "
                WriteStringN(OutFId, ReplC(sTrace), sf)
                EndOfCodeF = 1
                LastActFlag = #START_PB_SETTINGS
                
            EndIf
    
            If SkipCurrLineF: st = "SKIPPED: ": Else: st = "": EndIf    ; for debug
            ; Debug st + sLine
                    
            WriteString(OutFId, sLine, sf)
            WriteStringN(OutFId, "", sf)
            
    ;         CloseFile(OutFId)
    ;         OpenFile(OutFId, OutFN)
    ;         FileSeek(OutFId, Lof(OutFId))
                
        Wend

        CloseFile(InpFId)
        CloseFile(OutFId)
    
    EndIf

    ret = SendMessage_(FindWindow_(#Null, "Debug Output - "+GetFilePart(#PB_Compiler_File)), #WM_CLOSE, 0, 0)
    st = "Traced file: "+ InpFN+#CRLF$
    st = st + "to file    : "+ OutFN+#CRLF$
    st = st + "Stat: Lines Processed: "+Str(LineNr) + #CRLF$ +"            Added    : "+Str(LineNr - SkippedLines) + #CRLF$ +"            Skipped  : "+Str(SkippedLines)
         
    If Not SilentF : MessageRequester("Tracer", st): EndIf
    
    ProcedureReturn 0
    
EndProcedure ; /////////////////////////////////////////////////////////////////////////////


ret = TraceFile(InpFN, OutFN)


; Test generated code trying to compile it with minimal parameters
Define hMenu, EditMenu, CtrlX_mnuID, wParam, CompMenu, F5_mnuID, sRes.s =""


If TestCompileF
    ret = Recompile(InpFN, GetPathPart(InpFN), @sRes, #SILENT)
    
    If Not SilentF=0
        If Not ret 
            
            MessageRequester("Test Compilation: ERROR ", sRes, 16)
        Else
            MessageRequester("Test Compilation: OK", sRes)
        EndIf
    EndIf
    
EndIf


If ClearDebugViewLogF                                       ; clear DebugView Log
    hWnd = FindWindow_("dbgviewClass", #Null)
    If Not hWnd
        RunProgram("C:\Program Files\PureBasic_430\plugins\Dbgview.exe", " /f","") 
    EndIf
    
    If 0                                            ; two alternative ways of 
        SetForegroundWindow_(hWnd)                  ; must get input (foreground and active)
        SetActiveWindow_(hWnd)
        Sleep_(500)
        SendKey_(#VK_X, #VK_CONTROL)
        Sleep_(500)
        
    Else                                            ; no need to be foreground, but it doesn't work with the PureBasic editor
    
        hMenu = GetMenu_(hWnd)                      ; handle of the menu bar
        Editmenu = GetSubMenu_(hMenu, 1)            ; handle of the Edit Submenu (position 1 starting from 0=File)
        CtrlX_mnuID = GetMenuItemID_(EditMenu, 9)   ; MenuId of the Clear Display (Ctrl+X) menu item (9 his ordinal position starting from 0, including the separators)
        ;Debug ctrlxmenuid
        ;                                           LoW = 0 to 2^15 - HiW = 2^16 to 2^31 then 
        ; NotifyCode: wParam parameter composed by: HIWORD + LOWORD => HiW = Code, LoW = menuID then HiW = $00010000 (1*2^16) and LoW = Hex(CtrlX_mnuID) 
        ;                                           but for DebugView we have CtrlX_mnuID = 40020 
        ;                                           then wParam = $00010000 + Hex(40020) => $0001000 + $9C45 = $00019C45
        wParam = (1 * $10000 + CtrlX_mnuID)
        PostMessage_(hwnd, #WM_COMMAND, wParam, 0)  ; we do not need it to be in foreground window
    EndIf    
    Sleep_(20)
    
EndIf

SetForegroundWindow_(FindWindow_("WindowClass_2", #Null))

If RunPBF
    ret = MessageRequester("Tracer", "Start PureBasic?"+#CRLF$+#TAB$+"Yes=Run PB & Execute, No=Run PB, Cancel=Exit", #PB_MessageRequester_YesNoCancel)
    
    
    If (ret = #PB_MessageRequester_Yes Or ret = #PB_MessageRequester_No)
        Progr = RunProgram("c:\program files\purebasic_430\purebasic.exe", Chr(34)+OutFN+Chr(34)+" /local", GetPathPart(OutFN), #PB_Program_Open)
        pbPID = ProgramID(Progr)
        WaitForInputIdle_(pbPID, #INFINITE)
        Sleep_(500)

    EndIf

    If (ret = #PB_MessageRequester_Yes) 
        ;hWnd = FindWindow_("WindowClass_2", #Null )
        hWnd = GetForegroundWindow_()
        hWnd = GetActiveWindow_()
        hMenu = GetMenu_(hWnd)                      ; handle of the menu bar
        Compmenu = GetSubMenu_(hMenu, 2)            ; handle of the Compiler Submenu (position 1 starting from 0=File)
        F5_mnuID = GetMenuItemID_(CompMenu, 0)      ; MenuId of the Clear Display (Ctrl+X) menu item (9 his ordinal position starting from 0, including the separators)
        
        SendKey_(#VK_F5, 0)
    EndIf
EndIf


; this section includes the file containing the functions that are used by the 
; it is copyed at the beginning of the source file to trace
DataSection
    lblPBSource:
    IncludeBinary "TracerAux.pbi"
    EndlblPBSource:
EndDataSection 
; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 501
; FirstLine = 498
; Folding = -
; Markers = 411
; EnableThread
; UseIcon = Tools.ico
; Executable = ..\..\plugins\Tracer.exe
; CommandLine = "C:\Program Files\PureBasic_430\Arch\Tracer\Test_EnTimer.pb" /def
; EnableBuildCount = 41
; Watchlist = GetKeyWord()>kw;GetKeyWord()>sLine
; IncludeVersionInfo
; VersionField0 = 0.0.2.0
; VersionField1 = 0.0.2.0
; VersionField2 = none
; VersionField3 = Tracer
; VersionField4 = 0.0.2.0
; VersionField5 = 0.0.2.0
; VersionField6 = A program to automatically add debug output code to PB souces
; VersionField7 = Tracer
; VersionField8 = Tracer
; VersionField9 = Carlo Somigliana
; VersionField10 = Carlo Somigliana
; VersionField11 = %BUILDCOUNT
; VersionField12 = %BUILDCOUNT
; VersionField13 = somic@libero.it
; VersionField14 = www.semelinanno.com